> ## Documentation Index
> Fetch the complete documentation index at: https://docs.coingecko.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Coin Data by Token Address

> To query all the metadata (image, websites, socials, description, contract address, etc.) and market data (price, ATH, exchange tickers, etc.) of a coin based on an asset platform and a particular token contract address

export const CacheInfo = ({publicRate, paidRate, rate}) => {
  const fmt = v => v === 0 ? 'Real-time (Cacheless)' : `Every ${v}`;
  if (rate !== undefined) {
    return <Callout icon="clock-rotate-left" color="#2196F3" iconType="regular">
        <strong>Cache / Update Frequency:</strong><br />{fmt(rate)}
      </Callout>;
  }
  if (publicRate !== undefined && paidRate !== undefined) {
    return <Callout icon="clock-rotate-left" color="#2196F3" iconType="regular">
        <strong>Cache / Update Frequency:</strong><ul><li>{fmt(paidRate)} (Paid API)</li><li>{fmt(publicRate)} (Demo / Keyless API)</li></ul>
      </Callout>;
  }
  return null;
};

#### Notes

* Find a token's contract address on its [CoinGecko](https://www.coingecko.com) page or via [Coins List](/demo/reference/coins-list) with `include_platform=true`.
* Coin descriptions may contain `\r\n` escape sequences that require processing for proper formatting.

<CacheInfo rate="60 seconds" />

#### SDK Examples

<CodeGroup>
  ```typescript TypeScript theme={null}
  const response = await client.coins.contract.get('0xc02aaa39b223fe8d0a0e5c4f27ead9083c756cc2', {
    id: 'ethereum',
  });

  console.log(JSON.stringify(response, null, 2));
  ```

  ```python Python theme={null}
  response = client.coins.contract.get(
    "0xc02aaa39b223fe8d0a0e5c4f27ead9083c756cc2",
    id="ethereum",
  )

  print(response.model_dump_json(indent=2))
  ```
</CodeGroup>


## OpenAPI

````yaml openapi-specs/demo-api.json get /coins/{id}/contract/{contract_address}
openapi: 3.0.0
info:
  title: CoinGecko Demo API
  version: 3.0.0
servers:
  - url: https://api.coingecko.com/api/v3
security:
  - headerAuth: []
  - queryAuth: []
paths:
  /coins/{id}/contract/{contract_address}:
    get:
      summary: Coin Data by Token Address
      description: >-
        To query all the metadata (image, websites, socials, description,
        contract address, etc.) and market data (price, ATH, exchange tickers,
        etc.) of a coin based on an asset platform and a particular token
        contract address
      operationId: coins-contract-address
      parameters:
        - name: id
          in: path
          required: true
          description: |-
            Asset platform ID. 
            *refers to [`/asset_platforms`](/reference/asset-platforms-list).
          schema:
            type: string
            default: ethereum
        - name: contract_address
          in: path
          required: true
          description: The contract address of token.
          schema:
            type: string
            default: '0xc02aaa39b223fe8d0a0e5c4f27ead9083c756cc2'
      responses:
        '200':
          description: Coin data by token contract address
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CoinsContractAddress'
              example:
                id: weth
                symbol: weth
                name: WETH
                web_slug: weth
                asset_platform_id: ethereum
                platforms:
                  ethereum: '0xc02aaa39b223fe8d0a0e5c4f27ead9083c756cc2'
                  terra-2: >-
                    ibc/BC8A77AFBD872FDC32A348D3FB10CC09277C266CFE52081DE341C7EC6752E674
                  tron: THb4CqiFdwNHsWsQCs4JhzwjMWys4aqCbF
                detail_platforms:
                  ethereum:
                    decimal_place: 18
                    contract_address: '0xc02aaa39b223fe8d0a0e5c4f27ead9083c756cc2'
                    geckoterminal_url: >-
                      https://www.geckoterminal.com/eth/tokens/0xc02aaa39b223fe8d0a0e5c4f27ead9083c756cc2
                  terra-2:
                    decimal_place: 18
                    contract_address: >-
                      ibc/BC8A77AFBD872FDC32A348D3FB10CC09277C266CFE52081DE341C7EC6752E674
                  tron:
                    decimal_place: 18
                    contract_address: THb4CqiFdwNHsWsQCs4JhzwjMWys4aqCbF
                    geckoterminal_url: >-
                      https://www.geckoterminal.com/tron/tokens/THb4CqiFdwNHsWsQCs4JhzwjMWys4aqCbF
                block_time_in_minutes: 0
                hashing_algorithm: null
                categories:
                  - Crypto-Backed Tokens
                  - Wrapped-Tokens
                  - Terra Ecosystem
                  - Ethereum Ecosystem
                  - FTX Holdings
                  - Tron Ecosystem
                  - Index Coop Defi Index
                preview_listing: false
                public_notice: null
                additional_notices: []
                has_supply_breakdown: false
                localization:
                  en: WETH
                  de: ''
                  es: ''
                  fr: ''
                  it: ''
                  pl: ''
                  ro: ''
                  hu: ''
                  nl: ''
                  pt: ''
                description:
                  en: |-
                    What is WETH (Wrapped ETH)?
                    WETH is the tokenized/packaged form of ETH...
                links:
                  homepage:
                    - https://ethereum.org/en/wrapped-eth
                  whitepaper: ''
                  blockchain_site:
                    - >-
                      https://etherscan.io/token/0xc02aaa39b223fe8d0a0e5c4f27ead9083c756cc2
                    - https://intel.arkm.com/explorer/token/weth
                  official_forum_url: []
                  chat_url: []
                  announcement_url: []
                  snapshot_url: null
                  twitter_screen_name: ''
                  facebook_username: ''
                  bitcointalk_thread_identifier: null
                  telegram_channel_identifier: ''
                  subreddit_url: null
                  repos_url:
                    github: []
                    bitbucket: []
                image:
                  thumb: >-
                    https://coin-images.coingecko.com/coins/images/2518/thumb/weth.png?1696503332
                  small: >-
                    https://coin-images.coingecko.com/coins/images/2518/small/weth.png?1696503332
                  large: >-
                    https://coin-images.coingecko.com/coins/images/2518/large/weth.png?1696503332
                country_origin: ''
                genesis_date: '2016-06-17'
                contract_address: '0xc02aaa39b223fe8d0a0e5c4f27ead9083c756cc2'
                sentiment_votes_up_percentage: null
                sentiment_votes_down_percentage: null
                watchlist_portfolio_users: 34782
                market_cap_rank: null
                market_cap_rank_with_rehypothecated: 30
                market_data:
                  current_price:
                    btc: 0.02728343
                    eth: 0.99972363
                    usd: 2115.04
                  total_value_locked: null
                  mcap_to_tvl_ratio: null
                  fdv_to_tvl_ratio: null
                  roi: null
                  ath:
                    btc: 0.14280504
                    eth: 3.614831
                    usd: 4950.08
                  ath_change_percentage:
                    btc: -80.89678
                    eth: -72.33124
                    usd: -57.2622
                  ath_date:
                    btc: '2018-09-02T00:00:00.000Z'
                    eth: '2018-09-13T00:00:00.000Z'
                    usd: '2025-08-24T19:28:11.411Z'
                  atl:
                    btc: 0.00890197
                    eth: 0.22395179
                    usd: 82.1
                  atl_change_percentage:
                    btc: 206.45314
                    eth: 346.6045
                    usd: 2476.69436
                  atl_date:
                    btc: '2025-09-02T07:56:48.935Z'
                    eth: '2025-09-02T07:56:48.935Z'
                    usd: '2018-12-15T00:00:00.000Z'
                  market_cap:
                    btc: 61868
                    eth: 2267403
                    usd: 4793905266
                  market_cap_rank: null
                  outstanding_token_value_usd: null
                  market_cap_rank_with_rehypothecated: 30
                  fully_diluted_valuation:
                    btc: 61868
                    eth: 2267403
                    usd: 4793905266
                  market_cap_fdv_ratio: 1
                  total_volume:
                    btc: 107.294
                    eth: 3931
                    usd: 8317546
                  high_24h:
                    btc: 0.02756131
                    eth: 1.00272
                    usd: 2125.08
                  low_24h:
                    btc: 0.02717062
                    eth: 0.99799697
                    usd: 2068.79
                  price_change_24h: -3.316519511214
                  price_change_percentage_24h: -0.15656
                  price_change_percentage_7d: -0.0669
                  price_change_percentage_14d: -9.45938
                  price_change_percentage_30d: -8.82256
                  price_change_percentage_60d: 1.63545
                  price_change_percentage_200d: -37.57849
                  price_change_percentage_1y: -14.56267
                  market_cap_change_24h: -12121742.79577
                  market_cap_change_percentage_24h: -0.25222
                  price_change_24h_in_currency:
                    btc: -0.000274386252168236
                    eth: -0.000212661454704888
                    usd: -3.3165195112137553
                  price_change_percentage_1h_in_currency:
                    btc: -0.19183
                    eth: 0.00019
                    usd: -0.00865
                  price_change_percentage_24h_in_currency:
                    btc: -0.99568
                    eth: -0.02127
                    usd: -0.15656
                  price_change_percentage_7d_in_currency:
                    btc: -0.89914
                    eth: -0.05304
                    usd: -0.0669
                  price_change_percentage_14d_in_currency:
                    btc: -5.49184
                    eth: -0.04201
                    usd: -9.45938
                  price_change_percentage_30d_in_currency:
                    btc: -8.68383
                    eth: -0.02751
                    usd: -8.82256
                  price_change_percentage_60d_in_currency:
                    btc: -8.8249
                    eth: 0.0505
                    usd: 1.63545
                  price_change_percentage_200d_in_currency:
                    btc: -17.15793
                    eth: -0.10813
                    usd: -37.57849
                  price_change_percentage_1y_in_currency:
                    btc: 18.09057
                    eth: 0.19761
                    usd: -14.56267
                  market_cap_change_24h_in_currency:
                    btc: -635.7460114267669
                    eth: -986.7877555103041
                    usd: -12121742.795770645
                  market_cap_change_percentage_24h_in_currency:
                    btc: -1.01713
                    eth: -0.0435
                    usd: -0.25222
                  total_supply: 2267926.915444636
                  max_supply: null
                  max_supply_infinite: true
                  circulating_supply: 2267926.915444636
                  outstanding_supply: null
                  last_updated: '2026-05-25T10:09:02.821Z'
                community_data:
                  facebook_likes: null
                  reddit_average_posts_48h: 0
                  reddit_average_comments_48h: 0
                  reddit_subscribers: 0
                  reddit_accounts_active_48h: 0
                  telegram_channel_user_count: null
                developer_data:
                  forks: 0
                  stars: 0
                  subscribers: 0
                  total_issues: 0
                  closed_issues: 0
                  pull_requests_merged: 0
                  pull_request_contributors: 0
                  code_additions_deletions_4_weeks:
                    additions: null
                    deletions: null
                  commit_count_4_weeks: 0
                  last_4_weeks_commit_activity_series: []
                status_updates: []
                last_updated: '2026-05-25T10:09:02.821Z'
                tickers:
                  - base: WETH
                    target: USDC
                    market:
                      name: Native
                      identifier: native
                      has_trading_incentive: false
                    last: 2114.7318378964214
                    volume: 2999.739679821518
                    converted_last:
                      btc: 0.02728106
                      eth: 1.000065
                      usd: 2114.1
                    converted_volume:
                      btc: 81.256
                      eth: 2979
                      usd: 6296774
                    trust_score: null
                    bid_ask_spread_percentage: 0.04287
                    timestamp: '2026-05-25T10:04:42+00:00'
                    last_traded_at: '2026-05-25T10:04:42+00:00'
                    last_fetch_at: '2026-05-25T10:04:42+00:00'
                    is_anomaly: false
                    is_stale: false
                    trade_url: https://native.org/app/swap/
                    token_info_url: null
                    coin_id: weth
                    target_coin_id: usd-coin
                    coin_mcap_usd: 4793905265.563903
components:
  schemas:
    CoinsContractAddress:
      type: object
      required:
        - id
        - symbol
        - name
        - web_slug
        - asset_platform_id
        - platforms
        - detail_platforms
        - block_time_in_minutes
        - hashing_algorithm
        - categories
        - preview_listing
        - public_notice
        - additional_notices
        - has_supply_breakdown
        - description
        - links
        - image
        - country_origin
        - genesis_date
        - contract_address
        - sentiment_votes_up_percentage
        - sentiment_votes_down_percentage
        - watchlist_portfolio_users
        - market_cap_rank
        - market_cap_rank_with_rehypothecated
        - status_updates
        - last_updated
      properties:
        id:
          type: string
          description: Coin ID
        symbol:
          type: string
          description: Coin symbol
        name:
          type: string
          description: Coin name
        web_slug:
          type: string
          description: Coin web slug
        asset_platform_id:
          type: string
          nullable: true
          description: Coin asset platform ID
        platforms:
          type: object
          description: Coin asset platform and contract address
          additionalProperties:
            type: string
        detail_platforms:
          type: object
          description: Detailed coin asset platform and contract address
          additionalProperties:
            type: object
            properties:
              decimal_place:
                type: integer
                nullable: true
                description: Token decimal place
              contract_address:
                type: string
                description: Token contract address
              geckoterminal_url:
                type: string
                description: GeckoTerminal URL
        block_time_in_minutes:
          type: number
          description: Blockchain block time in minutes
        hashing_algorithm:
          type: string
          nullable: true
          description: Blockchain hashing algorithm
        categories:
          type: array
          description: Coin categories
          items:
            type: string
        preview_listing:
          type: boolean
          description: Preview listing coin
        public_notice:
          type: string
          nullable: true
          description: Public notice
        additional_notices:
          type: array
          description: Additional notices
          items:
            type: string
        has_supply_breakdown:
          type: boolean
          description: >-
            Whether detailed supply breakdown data is available via
            /coins/supply_breakdown
        localization:
          type: object
          description: Coin name localization
          additionalProperties:
            type: string
        description:
          type: object
          description: Coin description
          additionalProperties:
            type: string
        links:
          type: object
          description: Links
          properties:
            homepage:
              type: array
              description: Website URL
              items:
                type: string
            whitepaper:
              type: string
              description: Whitepaper URL
            blockchain_site:
              type: array
              description: Block explorer URL
              items:
                type: string
            official_forum_url:
              type: array
              description: Official forum URL
              items:
                type: string
            chat_url:
              type: array
              description: Chat URL
              items:
                type: string
            announcement_url:
              type: array
              description: Announcement URL
              items:
                type: string
            snapshot_url:
              type: string
              nullable: true
              description: Snapshot URL
            twitter_screen_name:
              type: string
              description: Twitter handle
            facebook_username:
              type: string
              description: Facebook username
            bitcointalk_thread_identifier:
              type: integer
              nullable: true
              description: Bitcointalk thread identifier
            telegram_channel_identifier:
              type: string
              description: Telegram channel identifier
            subreddit_url:
              type: string
              description: Subreddit URL
            repos_url:
              type: object
              description: Repository URL
              properties:
                github:
                  type: array
                  description: GitHub repository URL
                  items:
                    type: string
                bitbucket:
                  type: array
                  description: Bitbucket repository URL
                  items:
                    type: string
        image:
          type: object
          description: Coin image URL
          properties:
            thumb:
              type: string
            small:
              type: string
            large:
              type: string
        country_origin:
          type: string
          description: Country of origin
        genesis_date:
          type: string
          nullable: true
          description: Genesis date
        contract_address:
          type: string
          description: Coin contract address
        sentiment_votes_up_percentage:
          type: number
          nullable: true
          description: Sentiment votes up percentage
        sentiment_votes_down_percentage:
          type: number
          nullable: true
          description: Sentiment votes down percentage
        watchlist_portfolio_users:
          type: number
          description: Number of users watching this coin in portfolio
        market_cap_rank:
          type: integer
          nullable: true
          description: Market cap rank
        market_cap_rank_with_rehypothecated:
          type: integer
          nullable: true
          description: Market cap rank including rehypothecated tokens
        market_data:
          type: object
          description: Market data
          properties:
            current_price:
              type: object
              description: Current price in target currency
              additionalProperties:
                type: number
            total_value_locked:
              type: number
              nullable: true
              description: Total value locked
            mcap_to_tvl_ratio:
              type: number
              nullable: true
              description: Market cap to TVL ratio
            fdv_to_tvl_ratio:
              type: number
              nullable: true
              description: FDV to TVL ratio
            roi:
              type: object
              nullable: true
              description: Return on investment
              properties:
                times:
                  type: number
                  description: ROI multiplier
                currency:
                  type: string
                  description: ROI currency
                percentage:
                  type: number
                  description: ROI percentage
            ath:
              type: object
              description: All-time high in target currency
              additionalProperties:
                type: number
            ath_change_percentage:
              type: object
              description: All-time high change percentage
              additionalProperties:
                type: number
            ath_date:
              type: object
              description: All-time high date
              additionalProperties:
                type: string
            atl:
              type: object
              description: All-time low in target currency
              additionalProperties:
                type: number
            atl_change_percentage:
              type: object
              description: All-time low change percentage
              additionalProperties:
                type: number
            atl_date:
              type: object
              description: All-time low date
              additionalProperties:
                type: string
            market_cap:
              type: object
              description: Market cap in target currency
              additionalProperties:
                type: number
            fully_diluted_valuation:
              type: object
              description: Fully diluted valuation in target currency
              additionalProperties:
                type: number
            market_cap_fdv_ratio:
              type: number
              description: Market cap to FDV ratio
            market_cap_rank:
              type: integer
              nullable: true
              description: Market cap rank
            outstanding_token_value_usd:
              type: number
              nullable: true
              description: Outstanding token value in USD
            market_cap_rank_with_rehypothecated:
              type: integer
              nullable: true
              description: Market cap rank including rehypothecated tokens
            total_volume:
              type: object
              description: Total trading volume in target currency
              additionalProperties:
                type: number
            high_24h:
              type: object
              description: 24h price high in target currency
              additionalProperties:
                type: number
            low_24h:
              type: object
              description: 24h price low in target currency
              additionalProperties:
                type: number
            price_change_24h:
              type: number
              description: 24h price change in target currency
            price_change_percentage_24h:
              type: number
              description: 24h price change percentage
            price_change_percentage_7d:
              type: number
              description: 7d price change percentage
            price_change_percentage_14d:
              type: number
              description: 14d price change percentage
            price_change_percentage_30d:
              type: number
              description: 30d price change percentage
            price_change_percentage_60d:
              type: number
              description: 60d price change percentage
            price_change_percentage_200d:
              type: number
              description: 200d price change percentage
            price_change_percentage_1y:
              type: number
              description: 1y price change percentage
            market_cap_change_24h:
              type: number
              description: 24h market cap change in target currency
            market_cap_change_percentage_24h:
              type: number
              description: 24h market cap change percentage
            price_change_24h_in_currency:
              type: object
              description: 24h price change in target currency
              additionalProperties:
                type: number
            price_change_percentage_1h_in_currency:
              type: object
              description: 1h price change percentage per currency
              additionalProperties:
                type: number
            price_change_percentage_24h_in_currency:
              type: object
              description: 24h price change percentage per currency
              additionalProperties:
                type: number
            price_change_percentage_7d_in_currency:
              type: object
              description: 7d price change percentage per currency
              additionalProperties:
                type: number
            price_change_percentage_14d_in_currency:
              type: object
              description: 14d price change percentage per currency
              additionalProperties:
                type: number
            price_change_percentage_30d_in_currency:
              type: object
              description: 30d price change percentage per currency
              additionalProperties:
                type: number
            price_change_percentage_60d_in_currency:
              type: object
              description: 60d price change percentage per currency
              additionalProperties:
                type: number
            price_change_percentage_200d_in_currency:
              type: object
              description: 200d price change percentage per currency
              additionalProperties:
                type: number
            price_change_percentage_1y_in_currency:
              type: object
              description: 1y price change percentage per currency
              additionalProperties:
                type: number
            market_cap_change_24h_in_currency:
              type: object
              description: 24h market cap change in target currency
              additionalProperties:
                type: number
            market_cap_change_percentage_24h_in_currency:
              type: object
              description: 24h market cap change percentage per currency
              additionalProperties:
                type: number
            total_supply:
              type: number
              description: Total supply
            max_supply:
              type: number
              nullable: true
              description: Max supply
            max_supply_infinite:
              type: boolean
              description: Max supply infinite
            circulating_supply:
              type: number
              description: Circulating supply
            outstanding_supply:
              type: number
              nullable: true
              description: Tokens outstanding in the market
            last_updated:
              type: string
              description: Market data last updated timestamp
            sparkline_7d:
              type: array
              description: Sparkline 7-day price data
              items:
                type: number
        community_data:
          type: object
          description: Community data
          properties:
            facebook_likes:
              type: number
              nullable: true
              description: Facebook likes
            reddit_average_posts_48h:
              type: number
              description: Reddit average posts in 48 hours
            reddit_average_comments_48h:
              type: number
              description: Reddit average comments in 48 hours
            reddit_subscribers:
              type: number
              description: Reddit subscribers
            reddit_accounts_active_48h:
              type: number
              description: Reddit active accounts in 48 hours
            telegram_channel_user_count:
              type: number
              nullable: true
              description: Telegram channel user count
        developer_data:
          type: object
          description: Developer data
          properties:
            forks:
              type: number
              description: Repository forks
            stars:
              type: number
              description: Repository stars
            subscribers:
              type: number
              description: Repository subscribers
            total_issues:
              type: number
              description: Repository total issues
            closed_issues:
              type: number
              description: Repository closed issues
            pull_requests_merged:
              type: number
              description: Repository pull requests merged
            pull_request_contributors:
              type: number
              description: Repository pull request contributors
            code_additions_deletions_4_weeks:
              type: object
              description: Code additions and deletions in 4 weeks
              properties:
                additions:
                  type: number
                deletions:
                  type: number
            commit_count_4_weeks:
              type: number
              description: Repository commit count in 4 weeks
            last_4_weeks_commit_activity_series:
              type: array
              description: Repository last 4 weeks commit activity series
              items:
                type: number
        status_updates:
          type: array
          description: Status updates
          items:
            type: object
            properties:
              description:
                type: string
                description: Status update description
              category:
                type: string
                description: Status update category
              created_at:
                type: string
                description: Status update creation time
              user:
                type: string
                description: Status update user
              user_title:
                type: string
                description: Status update user title
        last_updated:
          type: string
          description: Last updated timestamp
        tickers:
          type: array
          description: Tickers
          items:
            type: object
            properties:
              base:
                type: string
                description: Ticker base currency
              target:
                type: string
                description: Ticker target currency
              market:
                type: object
                description: Ticker exchange
                properties:
                  name:
                    type: string
                    description: Exchange name
                  identifier:
                    type: string
                    description: Exchange identifier
                  has_trading_incentive:
                    type: boolean
                    description: Exchange trading incentive
              last:
                type: number
                description: Ticker last price
              volume:
                type: number
                description: Ticker volume
              converted_last:
                type: object
                description: Ticker converted last price
                properties:
                  btc:
                    type: number
                  eth:
                    type: number
                  usd:
                    type: number
              converted_volume:
                type: object
                description: Ticker converted volume
                properties:
                  btc:
                    type: number
                  eth:
                    type: number
                  usd:
                    type: number
              trust_score:
                type: string
                nullable: true
                description: Ticker trust score
              bid_ask_spread_percentage:
                type: number
                description: Ticker bid-ask spread percentage
              timestamp:
                type: string
                description: Ticker timestamp
              last_traded_at:
                type: string
                description: Ticker last traded timestamp
              last_fetch_at:
                type: string
                description: Ticker last fetch timestamp
              is_anomaly:
                type: boolean
                description: Ticker anomaly
              is_stale:
                type: boolean
                description: Ticker stale
              trade_url:
                type: string
                description: Ticker trade URL
              token_info_url:
                type: string
                nullable: true
                description: Ticker token info URL
              coin_id:
                type: string
                description: Ticker base currency coin ID
              target_coin_id:
                type: string
                description: Ticker target currency coin ID
              coin_mcap_usd:
                type: number
                description: Market cap in USD
  securitySchemes:
    headerAuth:
      type: apiKey
      in: header
      name: x-cg-demo-api-key
      description: >-
        Learn how to [set up your API
        key](https://docs.coingecko.com/docs/setting-up-your-api-key)
    queryAuth:
      type: apiKey
      in: query
      name: x_cg_demo_api_key
      description: >-
        Learn how to [set up your API
        key](https://docs.coingecko.com/docs/setting-up-your-api-key)

````